# SPDX-FileCopyrightText: 2019 Bryan Siepert for Adafruit Industries
#
# SPDX-License-Identifier: MIT

from time import sleep
import board
import busio
import adafruit_lsm303_accel
import adafruit_lis2mdl
import sys
import math
import os

i2c = busio.I2C(board.SCL, board.SDA)
mag = adafruit_lis2mdl.LIS2MDL(i2c)
accel = adafruit_lsm303_accel.LSM303_Accel(i2c)

x=0
### All values in MicroTeslas


cardinal="U"
## Initial hard iron compensation
try:
  fp = open("/home/pi/GPS/hard_iron_offsets","r");
  offsets = fp.read();
  fp.close()
except FileNotFoundError:
  # Write output file with no compass here
  print ("File not found")
  exit(); 

offset_a = offsets.split()
x_corr = int(offset_a[0])
y_corr = int(offset_a[1])
z_corr = int(offset_a[2])

mag_x, mag_y, mag_z = mag.magnetic;
acc_x, acc_y, acc_z = accel.acceleration;
mag_x, mag_y, mag_z = mag.magnetic;
acc_x, acc_y, acc_z = accel.acceleration;
mag_x, mag_y, mag_z = mag.magnetic;
acc_x, acc_y, acc_z = accel.acceleration;

mag_x = mag_x - x_corr
mag_y = mag_y - y_corr
mag_z = mag_z - z_corr

pitch = - math.atan(acc_x / math.sqrt(acc_y * acc_y + acc_z * acc_z))
roll = math.atan(acc_y / math.sqrt(acc_z * acc_z + acc_z * acc_z))

xh = mag_x * math.cos(pitch) + mag_y * math.sin(roll) * math.sin(pitch) - mag_z * math.cos(roll) * math.sin(pitch)
yh = mag_y * math.cos(roll) + mag_z * math.sin(roll)

tilt_compensated_heading =  ( math.atan2(yh,xh) ) * 180 / 3.1415
if (tilt_compensated_heading < 0) :tilt_compensated_heading = tilt_compensated_heading + 360

if ((tilt_compensated_heading > 335) or (tilt_compensated_heading <= 25)) : cardinal = "N";
if ((tilt_compensated_heading <= 335) and (tilt_compensated_heading > 295)) : cardinal = "NW";
if ((tilt_compensated_heading <= 295) and (tilt_compensated_heading > 245)) : cardinal = "W";
if ((tilt_compensated_heading <= 245) and (tilt_compensated_heading > 205)) : cardinal = "SW";
if ((tilt_compensated_heading <= 205) and (tilt_compensated_heading > 155)) : cardinal = "S";
if ((tilt_compensated_heading <= 155) and (tilt_compensated_heading > 115)) : cardinal = "SE";
if ((tilt_compensated_heading <= 115) and (tilt_compensated_heading > 65)) : cardinal = "E";
if ((tilt_compensated_heading <= 65) and (tilt_compensated_heading > 25)) : cardinal = "NE";
# Write cardinal to output file here

print (cardinal);

if len(sys.argv) > 1:
  gpsfile = open(sys.argv[1],'w');
  print(cardinal, file = gpsfile)
  gpsfile.close()
  os.chown(sys.argv[1],33,33)


