from time import sleep
import board
import busio
#import adafruit_lsm303_accel
import adafruit_lis2mdl
import os
import math
import numpy

i2c = busio.I2C(board.SCL, board.SDA)
mag = adafruit_lis2mdl.LIS2MDL(i2c)
#accel = adafruit_lsm303_accel.LSM303_Accel(i2c)

i=0
x_cal_datapoints = 0
y_cal_datapoints = 0
z_cal_datapoints = 0
### All values in MicroTeslas

mag_x_list = []
mag_y_list = []
mag_z_list = []
## Initial hard iron compensation

#Read calibration file first

while (i < 1000) :
    mag_x, mag_y, mag_z = mag.magnetic
    if (mag_x > 120): next;
    mag_x = int(mag_x);
    if (mag_x not in mag_x_list) : 
        mag_x_list.append(mag_x) 
        x_cal_datapoints = x_cal_datapoints + 1

    if (mag_y > 120): next;
    mag_y = int(mag_y);
    if (mag_y not in mag_y_list) : 
        mag_y_list.append(mag_y)
        y_cal_datapoints = y_cal_datapoints + 1

    if (mag_z > 120): next;
    mag_z = int(mag_z);
    if (mag_z not in mag_z_list) : 
        mag_z_list.append(mag_z)
        z_cal_datapoints = z_cal_datapoints + 1

    if ((x_cal_datapoints > 60) and (y_cal_datapoints > 60) and (z_cal_datapoints > 60)):
        break
    i = i + 1
    sleep(.1)

mag_x_list.sort()
mag_y_list.sort()
mag_z_list.sort()

#print (*mag_x_list, sep=',')
#print (*mag_y_list, sep=',')
#print (*mag_z_list, sep=',')

x_offset = sum(mag_x_list) / len(mag_x_list)
y_offset = sum(mag_y_list) / len(mag_y_list)
z_offset = sum(mag_z_list) / len(mag_z_list)
results = str(int(x_offset)) + " " + str(int(y_offset)) + " " + str(int(z_offset))

print( results)

fp = open (r"/home/pi/GPS/hard_iron_offsets", "w")
fp.write(results)
fp.close()


