import os
import sys
from gps import *
import time
import RPi.GPIO as GPIO

print ('Set System Clock to GPS UTC time')

try:
  gpsd = gps(mode=WATCH_ENABLE)
except:
  print ('ERROR: No GPS Present, time not set!!')
  sys.exit()

sched_running = 0

sys.stdout.flush()
tries = 0
x = 0
while x < 2:
  #wait until the next GPSD time tick
  gpsd.next()
  tries = tries + 1
  #if (tries > 1000):  ### Need this to work eventually
  #  x=1; # break
  if x == 0 and gpsd.utc != None and gpsd.utc != '':
    #gpsd.utc is formatted like"2015-04-01T17:32:04.000Z"
    #convert it to a form the date -u command will accept: "20140401 17:32:04"
    #use python slice notation [start:end] (where end desired end char + 1)
    #   gpsd.utc[0:4] is "2015"
    #   gpsd.utc[5:7] is "04"
    #   gpsd.utc[8:10] is "01"
    gpsutc = gpsd.utc[0:4] + gpsd.utc[5:7] + gpsd.utc[8:10] + ' ' + gpsd.utc[11:19]
    #    This should be a trivial reset, except for the first time we get a GPS fix.  Setting the time now prevents needing to reset to get the correct time sync'd on first run.  
    print ('setting OS time to ')
    print (gpsutc)
    os.system('sudo date -u --set="%s"' % gpsutc)
    print ('setting physic RTC hwclock time to ')
    print (gpsutc)
    os.system('sudo hwclock -w')
    x = 1;
  if x == 1: 
    print (gpsd.fix.latitude)
    print (gpsd.fix.longitude)
    sys.stdout.flush()
    if len(str(gpsd.fix.longitude)) > 4:
      ## OK - we have a good initial fix - set the timezone if necessary
      ## Is scheduler running?

      os.system("ps -ef | grep simple_schedule | grep -v grep | wc -l > /home/pi/sched_running_status")


      with open('/etc/timezone') as f:
        before_timezone = f.readlines()

      command = "python3 /home/pi/GPS/set_tz.py " + str(gpsd.fix.latitude) + " " + str(gpsd.fix.longitude);
      os.system(command);

      with open('/etc/timezone') as f:
        after_timezone = f.readlines()

      with open('/home/pi/sched_running_status') as f:
        sched_running_str = f.readlines()
        sched_running = int(sched_running_str[0]); 
      

      print ("Schedule status: %d " % sched_running);

      if (sched_running > 0):
        print ("Scheduler was running!  Restart it if we changed timezones!")

      #IF timezone changed AND IF the scheduler was running, restart scheduler
      if (after_timezone != before_timezone):
        print ("Schedule was running and we switched timezones.  Restart php and simple_schedule to get new timezone in php engine")
        ## restart the scheduler to take the new timezone.
        os.system("systemctl restart php7.3-fpm.service"); 

        if (sched_running):
        ## Restart scheduler if it was running before
          os.system("wget http://localhost/simple_schedule.php?action=start -O /dev/null");

      x = 2;



   
# we've set system time, turn off the GPS module.
#os.system('python /home/pi/GPS/stopgps.py');

sys.exit()



